//if (!window['xm']) {
//	window['xm'] = {};
//};
var xm = {};

xm.plusReady = function(callback) {
	mui.plusReady(function() {
		var appid = plus.runtime.appid;
		xm.config = {
			server: appid == "HBuilder" ? "http://api.xinmi360.net/api/" : "http://api.xinmi360.com/api/",
			device: {
				geolocation: plus.storage.getItem("geolocation"),
				client: plus.push.getClientInfo(),

				network: plus.networkinfo.getCurrentType(),
				app_id: appid,
				app_version: plus.runtime.version,
				app_innerversion: plus.runtime.innerVersion,
				hardware_model: plus.device.model, //设备
				hardware_vendor: plus.device.vendor, //厂商
				hardware_imei: plus.device.imei,
				hardware_uuid: plus.device.uuid,
				hardware_imsi: plus.device.imsi,
				os_name: plus.os.name, //名称
				os_version: plus.os.version, //系统版本
				os_language: plus.os.language, //语言
				os_vendor: plus.os.vendor, //厂商
				screen_resolutionWidth: plus.screen.resolutionWidth,
				screen_resolutionHeight: plus.screen.resolutionHeight,
				screen_scale: plus.screen.scale,
			}
		};
		callback && callback();
	});
};

xm.ajax = function(options) {
	options.waiting && plus.nativeUI.showWaiting();
	mui.ajax(xm.config.server + options.url, {
		data: {
			token: plus.storage.getItem("token"),
			device: xm.config.device,
			data: options.data
		},
		dataType: "json",
		type: options.type || "get",
		timeout: 5000, //10秒；
		success: function(res) {
			xm.log(res);
			if (res.code < 0) {
				if (res.code == -1) {
					plus.nativeUI.alert(res.msg.description, "", res.msg.title);
				} else if (res.code == -2) {
					plus.nativeUI.confirm(res.msg.description, function(e) {
						if (e.index == 1) {
							plus.runtime.openURL(res.url);
						}
					}, res.msg.title, ["取消", "更新"]);
				}
			} else {
				options.success && options.success(res);
			};
			options.waiting && plus.nativeUI.closeWaiting();
		},
		error: function(xhr, type, errorThrown) {
			xm.log(xhr.responseText);
			options.waiting && plus.nativeUI.closeWaiting();
			options.err && plus.nativeUI.alert("你的网络不稳定请检查网络", "", "登录失败");
			options.error && options.error();
		}
	});
};

//初始化每个请求的页面
xm.loadPage = function(url, data, callback) {
	xm.ajax({
		url: url,
		data: data,
		waiting: true,
		success: function(res) {
			if (res.code == 0) {
				var html = template('template', res);
				$('.xm-content').html(html);
				callback && callback(res);
			} else {
				plus.nativeUI.alert("系统繁忙，请稍后再试", "", "加载失败");
			}
		},
		error: function() {
			plus.nativeUI.alert("网络不给力，请稍后重试", "", "加载失败");
		}
	});
};
//初始化每个请求的页面
xm.updatePage = function(url, data, callback) {
	var w = plus.webview.currentWebview();
	xm.ajax({
		url: url,
		data: data,
		success: function(res) {
			if (res.code == 0) {
				var html = template('template', res);
				$('.xm-content').html(html);
				callback && callback(res);
				w.endPullToRefresh();
			} else {
				w.endPullToRefresh();
			}
		},
		error: function() {
			w.endPullToRefresh();
		}
	});
};

xm.setPullToRefresh = function(callback) {
	//下拉刷新
	var ws = plus.webview.currentWebview();
	ws.setPullToRefresh({
		support: true,
		height: "50px",
		range: "200px",
		contentdown: {
			caption: "下拉可以刷新"
		},
		contentover: {
			caption: "释放立即刷新"
		},
		contentrefresh: {
			caption: "正在刷新...",
		}
	}, function() {
		callback();
	});
};

xm.log = function(data, type) {
	if (xm.config.device.app_id == "HBuilder") {
		if (type) {
			console.log(data);
		} else {
			console.log(JSON.stringify(data));
		}
	}
};

xm.updateGeolocation = function() {
	plus.geolocation.getCurrentPosition(function(position) {
		plus.storage.setItem("geolocation", JSON.stringify(position));
	}, function(e) {
		xm.log(e.message);
	}, {
		enableHighAccuracy: false,
		timeout: 30 * 1000,
		maximumAge: 5 * 60 * 1000,
		provider: "baidu",
		geocode: true
	});
};

xm.getToken = function() {
	return plus.storage.getItem("token");
};
xm.is_login = function() {
	if (plus.storage.getItem('token')) {
		return true;
	} else {
		return false;
	}
};

//窗口切换
xm.openTab = function(url, id) {
	if (!xm.getToken()) {
		plus.webview.open("../passport/login.html", "passport/login.html", "", "slide-in-bottom");
		return;
	}
	if (!plus.webview.getWebviewById(id)) {
		var self = plus.webview.getLaunchWebview();
		var sub = plus.webview.create(url, id);
		self.append(sub);
		plus.webview.currentWebview().hide();
	} else {
		plus.webview.show(id);
		plus.webview.currentWebview().hide();
	}
};
//打开新窗口
xm.openWindow = function(url, id, extras) {
	id = id ? id : url;
	if (!plus.webview.getWebviewById(id)) {
		plus.webview.create(url, id, "", extras).show("pop-in");
	}
};
 
//网络连接失败 函数
xm.errorNet = function() {
	var html;
	html = "<div class='flex-center' style='height: 100%;'><div style='width:100%;text-align:center;'><div class='i-xinmi-wifi flex-center' style='color:#ccc;font-size:6.0rem;display:block'></div><p style='font-size:1.0rem;color:#a3a3a3;padding:0.5rem 3rem 1.5rem'>网络连接失败</p><button class='btn' style='padding:0.8rem 3.5rem;border:1px solid #c8c8c8;color:#a3a3a3' onclick='xm.onRefresh()'>重新加载</button></div></div>";
	return html;
}


//网络连接失败 函数
xm.errorOther = function(err) {
	var html;
	html = "<div class='flex-center' style='height: 100%;'><div style='width:100%;text-align:center;'><div class='i-xinmi-wifi flex-center' style='color:#ccc;font-size:6.0rem;display:block'></div><p style='font-size:1.0rem;color:#a3a3a3;padding:0.5rem 3rem 1.5rem'>" + err +
		"</p><button class='btn' style='padding:0.8rem 3.5rem;border:1px solid #c8c8c8;color:#a3a3a3' onclick='xm.onRefresh()'>重新加载</button></div></div>";
	return html;
}

xm.sendSms = function(obj, type) {
	//短信
	var dom = $(obj);
	dom.attr("disabled", "disabled");
	var mobile = $("#mobile").val();
	if (mobile.length != 11) {
		plus.nativeUI.alert('请核对手机位数是否正确！', '', '手机号码不正确');
		dom.removeAttr("disabled");
		return;
	};
	xm.ajax({
		url: "Passport/sendSms",
		data: {
			"mobile": mobile,
			"type": type
		},
		type: 'post',
		waiting: true,
		success: function(res) {
			if (res.code == 0) {
				var a = 60;
				dom.text("" + a + "秒后重新获取");
				var s = setInterval(function() {
					//等待中
					a--;
					dom.text("" + a + "秒后重新获取");
					//等待结束
					if (a < 0) {
						dom.text("获取验证码");
						dom.removeAttr("disabled");
						clearInterval(s)
					}
				}, 1000);
				plus.nativeUI.alert(res.msg, '', '获取成功');
			} else {
				dom.removeAttr("disabled");
				plus.nativeUI.alert(res.msg, '', '获取失败');
			}
		},
		error: function() {
			dom.removeAttr("disabled");
			plus.nativeUI.alert("网络不给力，请稍后重试", "", "获取失败");
		}
	});
}